> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.prolific.com/llms.txt.
> For full documentation content, see https://docs.prolific.com/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.prolific.com/_mcp/server.

# Request a feedback upload URL

GET https://api.prolific.com/api/v1/submissions/signals/upload-url/{filename}

Request a temporary, pre-signed URL to upload a feedback file for your completed studies.

This is the first step of a two-step upload process:
  1. Call this endpoint to receive a pre-signed `upload_url`.
  2. Upload your file directly to that URL with an HTTP `PUT` request before it expires.

<Note>
  Supported file formats are CSV, XLS, XLSX, JSON, TXT and PDF. The maximum file size is 5GB. Please check the [supported file formats](/api-reference/submission-feedback-upload#supported-file-formats) section for more details.
</Note>

Reference: https://docs.prolific.com/api-reference/submission-feedback-upload/get-submission-feedback-upload-url

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Prolific API for Data Collectors
  version: 1.0.0
paths:
  /api/v1/submissions/signals/upload-url/{filename}:
    get:
      operationId: get-submission-feedback-upload-url
      summary: Request a feedback upload URL
      description: >-
        Request a temporary, pre-signed URL to upload a feedback file for your
        completed studies.


        This is the first step of a two-step upload process:
          1. Call this endpoint to receive a pre-signed `upload_url`.
          2. Upload your file directly to that URL with an HTTP `PUT` request before it expires.

        <Note>
          Supported file formats are CSV, XLS, XLSX, JSON, TXT and PDF. The maximum file size is 5GB. Please check the [supported file formats](/api-reference/submission-feedback-upload#supported-file-formats) section for more details.
        </Note>
      tags:
        - subpackage_submissionFeedbackUpload
      parameters:
        - name: filename
          in: path
          description: >-
            The name of the file you want to upload, including its extension
            (e.g. `participant_feedback.csv`).
          required: true
          schema:
            type: string
        - name: workspace_id
          in: query
          description: The ID of the Prolific workspace the feedback belongs to.
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            The Prolific API uses API token to authenticate requests. You can
            create an API token directly from your settings.


            Your API token does not have an expiry date and carries full
            permission, so be sure to keep them secure.


            If your token is leaked, delete it and create a new one directly in
            the app.


            In your requests add `Authorization` header with the value `Token
            <your token>`.
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Pre-signed upload URL generated successfully.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Submission Feedback
                  Upload_GetSubmissionFeedbackUploadUrl_Response_201
        '400':
          description: Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
servers:
  - url: https://api.prolific.com
components:
  schemas:
    ApiV1SubmissionsSignalsUploadUrlFilenameGetResponsesContentApplicationJsonSchemaHttpMethod:
      type: string
      enum:
        - PUT
      description: The HTTP method to use when uploading to `upload_url`.
      title: >-
        ApiV1SubmissionsSignalsUploadUrlFilenameGetResponsesContentApplicationJsonSchemaHttpMethod
    Submission Feedback Upload_GetSubmissionFeedbackUploadUrl_Response_201:
      type: object
      properties:
        upload_url:
          type: string
          description: >-
            The temporary, pre-signed URL to upload your file to with an HTTP
            `PUT` request.
        http_method:
          $ref: >-
            #/components/schemas/ApiV1SubmissionsSignalsUploadUrlFilenameGetResponsesContentApplicationJsonSchemaHttpMethod
          description: The HTTP method to use when uploading to `upload_url`.
        expires_at:
          type: string
          format: date-time
          description: The time at which the pre-signed `upload_url` expires.
      title: Submission Feedback Upload_GetSubmissionFeedbackUploadUrl_Response_201
    ErrorDetailDetail2:
      type: object
      properties:
        any_field:
          type: array
          items:
            type: string
          description: >-
            Name of the field with a validation error and as a value an array
            with the error descriptions
      description: All fields with validation errors
      title: ErrorDetailDetail2
    ErrorDetailDetail:
      oneOf:
        - type: string
        - type: array
          items:
            type: string
        - $ref: '#/components/schemas/ErrorDetailDetail2'
      description: Error detail
      title: ErrorDetailDetail
    ErrorDetail:
      type: object
      properties:
        status:
          type: integer
          description: Status code as in the http standards
        error_code:
          type: integer
          description: Internal error code
        title:
          type: string
          description: Error title
        detail:
          $ref: '#/components/schemas/ErrorDetailDetail'
          description: Error detail
        additional_information:
          type: string
          description: Optional extra information
        traceback:
          type: string
          description: Optional debug information
        interactive:
          type: boolean
      required:
        - status
        - error_code
        - title
        - detail
      title: ErrorDetail
    Error:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/ErrorDetail'
      required:
        - error
      title: Error
  securitySchemes:
    token:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        The Prolific API uses API token to authenticate requests. You can create
        an API token directly from your settings.


        Your API token does not have an expiry date and carries full permission,
        so be sure to keep them secure.


        If your token is leaked, delete it and create a new one directly in the
        app.


        In your requests add `Authorization` header with the value `Token <your
        token>`.

```

## SDK Code Examples

```python
import requests

url = "https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv"

querystring = {"workspace_id":"6278acb09062db3b35bcb123"}

headers = {"Authorization": "Token <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123';
const options = {method: 'GET', headers: {Authorization: 'Token <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Token <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Token <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123")
  .header("Authorization", "Token <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123', [
  'headers' => [
    'Authorization' => 'Token <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Token <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Token <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```